# CreateSnatEntry

## 1. API Description

This API (CreateSnatEntry) is used to create a SNAT rule.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

<mark style="color:blue;">By default, you can create up to 10 SNAT entries for a NAT gateway. For additional quota, please contact us.</mark>
{% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name   | Required | Type            | Description                                                                                                                                                                                        |
| ---------------- | -------- | --------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| natGatewayId     | Yes      | String          | NAT gateway ID.                                                                                                                                                                                    |
| eipIds           | No       | Array of String | The elastic IP ID configured in the SNAT rule. If the value is empty, it means all the elastic IPs bound to the NAT gateway.                                                                       |
| cidr             | No       | String          | <p>CIDR block.</p><p>Either cidr or subnetIds must be specified.</p>                                                                                                                               |
| sourceCidrBlocks | No       | Array of String | <p>List of source CIDR blocks.</p><p>One of <code>sourceCidrBlocks</code> and <code>subnetIds</code> must be specified.</p><p>To use the entire address range, specify <code>0.0.0.0/0</code>.</p> |
| subnetIds        | No       | Array of String | <p>IDs of subnets.</p><p>Either cidr or subnetIds must be specified.</p>                                                                                                                           |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| snatEntryId    | String | The unique ID of the SNAT rule.                                                                                       |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Create a SNAT entry of type `subnet`.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: CreateSnatEntry
<Common Request Params>

Request：
{
  "natGatewayId": "<natGatewayId>",
  "subnetIds": ["<subnetId>"],
  "eipIds": ["<eipId>"]
}


Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
    "snatEntryId": "<snatEntryId>"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).

| HTTP Status Code | Error Code                                             | Description                                             |
| ---------------- | ------------------------------------------------------ | ------------------------------------------------------- |
| 404              | INVALID\_NAT\_NOT\_FOUND                               | NAT gateway does not exist.                             |
| 400              | OPERATION\_DENIED\_NAT\_STATUS                         | NAT gateway state is not RUNNING.                       |
| 404              | INVALID\_EIP\_NOT\_FOUND                               | Elastic IP does not exist.                              |
| 400              | OPERATION\_DENIED\_EIP\_NOT\_ASSIGNED                  | Elastic IP is not bound.                                |
| 400              | OPERATION\_DENIED\_EIP\_NOT\_ASSIGN\_NAT               | The elastic IP isn't assigned to the NAT gateway.       |
| 400              | OPERATION\_DENIED\_ANYPORT\_DNAT\_ENTRY                | DNAT mapping method is Any Port.                        |
| 400              | OPERATION\_DENIED\_SNAT\_ENTRY\_COUNT\_LIMIT           | The number of SNAT entries is limited.                  |
| 400              | INVALID\_CIDR\_FORMAT                                  | The specified CIDR block format error.                  |
| 404              | INVALID\_NAT\_SUBNET\_NOT\_FOUND                       | The specified subnet does not exist on the NAT gateway. |
| 400              | OPERATION\_DENIED\_CIDR\_CONFLICT\_WITH\_SNAT\_ENTRY   | The specified CIDR conflicts with another SNAT rule.    |
| 400              | OPERATION\_DENIED\_NAT\_SUBNET\_CONFLICT               | Subnet is associated already.                           |
| 400              | OPERATION\_DENIED\_NAT\_ENTRY\_CONFIG\_CONFLICT        | NAT rules conflict.                                     |
| 400              | OPERATION\_DENIED\_SUBNET\_CONFLICT\_WITH\_SNAT\_ENTRY | The specified subnet conflicts with another SNAT rule.  |
